import React from "react";
import { StyleProp, ViewStyle, ViewProps } from "react-native";
import type { CollapsibleProps } from "react-native-collapsible";
import { ArrowDownIconStyling } from "./ArrowDownIcon";
import { MakePropsOptional } from "./types";
interface CollapsibleViewProps {
    children: React.ReactNode;
    title?: string | React.ReactNode;
    initExpanded?: boolean;
    expanded?: boolean | null;
    unmountOnCollapse?: boolean;
    isRTL?: boolean | "auto";
    duration?: number;
    collapsibleProps?: MakePropsOptional<CollapsibleProps>;
    collapsibleContainerStyle?: ViewStyle;
    arrowStyling?: ArrowDownIconStyling;
    noArrow?: boolean;
    style?: StyleProp<ViewStyle>;
    activeOpacityFeedback?: number;
    TouchableComponent?: React.ComponentType<any>;
    titleProps?: ViewProps;
    titleStyle?: ViewStyle;
    touchableWrapperStyle?: StyleProp<ViewStyle>;
    touchableWrapperProps?: ViewProps;
}
declare const CollapsibleView: ({ children, title, initExpanded, expanded, unmountOnCollapse, isRTL, duration, collapsibleProps, collapsibleContainerStyle, arrowStyling, noArrow, style, activeOpacityFeedback, TouchableComponent, titleProps, titleStyle, touchableWrapperStyle, touchableWrapperProps, }: CollapsibleViewProps) => React.JSX.Element;
export default CollapsibleView;
//# sourceMappingURL=index.d.ts.map