"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_collapsible_1 = __importDefault(require("react-native-collapsible"));
const ArrowDownIcon_1 = __importDefault(require("./ArrowDownIcon"));
const CollapsibleView = ({ children, title = "", initExpanded = false, expanded = null, unmountOnCollapse = false, isRTL = "auto", duration = 300, collapsibleProps = {}, collapsibleContainerStyle = {}, arrowStyling, noArrow = false, style = {}, activeOpacityFeedback = 0.3, TouchableComponent = react_native_1.TouchableOpacity, titleProps = {}, titleStyle = {}, touchableWrapperStyle = {}, touchableWrapperProps = {}, }) => {
    let controlled = expanded !== null;
    const [show, setShow] = (0, react_1.useState)(initExpanded);
    const [mounted, setMounted] = (0, react_1.useState)(initExpanded);
    const rotateAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    if (controlled) {
        if (!mounted && expanded)
            setMounted(true);
    }
    const handleArrowRotate = (open = null) => {
        const _open = open === null ? show : open;
        if (!_open)
            react_native_1.Animated.timing(rotateAnim, {
                toValue: 0,
                duration,
                easing: react_native_1.Easing.ease,
                useNativeDriver: false,
            }).start();
        else {
            react_native_1.Animated.timing(rotateAnim, {
                toValue: rotateAngle,
                duration,
                easing: react_native_1.Easing.ease,
                useNativeDriver: false,
            }).start();
        }
    };
    const handleAnimationEnd = () => {
        if (unmountOnCollapse && !show)
            setMounted(false);
    };
    const handleToggleShow = () => {
        if (!controlled)
            if (!mounted) {
                if (!show)
                    setMounted(true);
            }
            else {
                setShow(!show);
            }
    };
    // place the arrow on the left or the right based on the device direction and isRTL property
    let rowDir = "row";
    if (isRTL === "auto")
        isRTL = react_native_1.I18nManager.isRTL;
    else if (isRTL !== react_native_1.I18nManager.isRTL)
        rowDir = "row-reverse";
    const rotateAngle = isRTL ? 90 : -90;
    const rotateAnimDeg = rotateAnim.interpolate({
        inputRange: [0, 360],
        outputRange: ["0deg", "360deg"],
    });
    const TitleElement = typeof title === "string" ? react_1.default.createElement(react_native_1.Text, { style: styles.TitleText }, title) : title;
    (0, react_1.useEffect)(() => {
        // this part is to trigger collapsible animation only after he has been fully mounted so animation would
        // not be interrupted.
        if (mounted) {
            setShow(true);
            // handleArrowRotate();
        }
    }, [mounted]);
    (0, react_1.useEffect)(() => {
        // on mounting set the rotation angel
        rotateAnim.setValue(show ? 0 : rotateAngle);
    }, []);
    (0, react_1.useEffect)(() => {
        if (mounted)
            handleArrowRotate(!show);
        if (controlled && show != expanded)
            setShow(expanded);
    });
    return (react_1.default.createElement(TouchableComponent, { style: [styles.container, style, touchableWrapperStyle], onPress: handleToggleShow, activeOpacity: activeOpacityFeedback, ...touchableWrapperProps },
        react_1.default.createElement(react_native_1.View, { style: {
                flexDirection: rowDir,
                alignItems: "center",
                ...titleStyle,
            }, ...titleProps },
            noArrow ? null : (react_1.default.createElement(react_native_1.Animated.View, { style: { transform: [{ rotate: rotateAnimDeg }] } },
                react_1.default.createElement(ArrowDownIcon_1.default, { ...arrowStyling }))),
            TitleElement),
        mounted ? (react_1.default.createElement(react_native_1.View, { style: { width: "100%", ...collapsibleContainerStyle } },
            react_1.default.createElement(react_native_collapsible_1.default, { onAnimationEnd: handleAnimationEnd, collapsed: !show, duration, ...collapsibleProps }, children))) : null));
};
exports.default = CollapsibleView;
const styles = react_native_1.StyleSheet.create({
    container: {
        alignItems: "center",
        marginHorizontal: 10,
        marginVertical: 5,
        padding: 5,
        borderColor: "grey",
        borderWidth: 1,
        borderStyle: "solid",
    },
    TitleText: { color: "#3385ff", fontSize: 16, padding: 5 },
});
//# sourceMappingURL=index.js.map